Leetcode[4] Median of two sorted arrays

Leetcode[4] Median of two sorted arrays

There are two sorted arrays nums1 and nums2 of size m and n
respectively.

Find the median of the two sorted arrays. The overall run time
complexity should be O(log (m+n)).數組

Example 1: nums1 = [1, 3] nums2 = [2]code

The median is 2.0 Example 2: nums1 = [1, 2] nums2 = [3, 4]it

The median is (2 + 3)/2 = 2.5io

Binary search

複雜度
O(lg(m + n))class

思路
由於要找中位數,又是在兩個sorted的數組裏面。因此考慮用二分法。(二分法常常適合sorted的array).
接下來考慮如何二分。
假設第k個數是咱們要找的中位數,那麼前k-1個數應該都比這個第k個數要小。後面的數都比這個第k個數大。(像變形的用二分法找第K個數)。
若是咱們每次在a數組中找前(k/2) = m個數,在b數組中找剩下的(k-k/2) = n個數。而後對a[p + k/2 - 1]和b[q + k - k/2 -1]進行比較,記爲a[i]和b[j]。搜索

  • a[i] < b[j]: 說明咱們能夠扔掉0-i之間的(i+ 1)個數。爲何?
    由於a數組中的前m個數的最大值都比b數組中的前n個數要小,那麼這前m個數必定是在咱們想要的中位數以前的,而且對找到中位數沒有說明影響。因此爲了縮小搜索範圍,咱們能夠扔掉這些數,在a的剩下來的數中和b的數組中接着找。
  • i>=a.length: 說明a中沒有m個數能夠尋找。那麼第K個數要麼在b剩下的數組[n ~ b.length]中,要麼就在a的前m個數中。

一直搜索到何時爲止呢?
k=1表明的是,當前的這個是就是咱們想要的值,咱們應該在如何選擇? Math.min(a[p], b[q]).im

if(a[i] < b[j]) {
  search(a[right], b[0], k - m);
} else {
  search (a[0], b[right], k - n);
}

咱們從找第K個數開始,一直到K=1,每次扔掉一部分數 k /2,因此時間複雜度是log(k).
K=(M + N) / 2, 因此時間複雜度是log(m + n)sort

代碼di

class Solution {
    // 其實找的是第k個值。
    public double findMedianSortedArrays(int[] nums1, int[] nums2) {
        int len = nums1.length + nums2.length;
        if(len % 2 == 0) {
            return findKthNumberInTwoArray(nums1, nums2, 0, 0, len / 2) / 2 
                + findKthNumberInTwoArray(nums1, nums2, 0, 0, len / 2 + 1) / 2;
        } else {
            return findKthNumberInTwoArray(nums1, nums2, 0, 0, len / 2 + 1);
        }     
    }
    
    // p is the start index of nums1, q is the start index of nums2, we wanna find the kth number 
    // in both num1 & nums2
    public double findKthNumberInTwoArray(int[] nums1, int[] nums2, int p, int q, int k) {
        if(p >= nums1.length) return nums2[q + k - 1];
        if(q >= nums2.length) return nums1[p + k - 1];
        if(k == 1) return Math.min(nums1[p], nums2[q]);
        
        int m = k / 2, n = k - m;
        // 由於當a數組沒有中這個數的時候,說明第k必定在b數組剩餘的數中和a數組的剩餘數組中的一個。
        int aVal = Integer.MAX_VALUE, bVal = Integer.MAX_VALUE;
        if(p + m - 1 < nums1.length) aVal = nums1[p + m - 1];
        if(q + n - 1 < nums2.length) bVal = nums2[q + n - 1];
        
        if(aVal < bVal) {
            return findKthNumberInTwoArray(nums1, nums2, p + m, q, k - m);
        } else {
            return findKthNumberInTwoArray(nums1, nums2, p, q + n, k - n);
        }
    }
}
相關文章
相關標籤/搜索